forecast_rGARCH_MLE_jump_n <- function(est, fitted, jumps, rv1, ar = 0, steps = 1) {
	jumps <- log(1+jumps)
	φ <- est$optim_vals[["φ"]]
	d1 <- est$optim_vals[["d1"]]
	d2 <- est$optim_vals[["d2"]]
	λ <- fitted[["lambda"]][length(fitted[["lambda"]])]
	γ <- est$optim_vals[["γ"]]
	β <- est$optim_vals[["β"]]
	ω <- est$optim_vals[["ω"]]
	ξ <- est$optim_vals[["ξ"]]
	
	if (length(steps) == 1) {
		pred <- rep(NA, steps)

		pred[1] <- ω + β*λ + γ*rv1
		if (steps == 1) {
			return(list(logvol=pred, jumps = predict(arima(jumps, order = c(ar,0,0)), n.ahead = steps)))
		}

		for (i in 1:(steps-1)) {
			# Because ε is martingale difference sequence the expected value should be zero	
			vol <- ξ + φ*pred[i] + d2 * mean(fitted[["z"]]^2)
			pred[i+1] <- ω + β * pred[i] + γ * vol
		}
		return(list(logvol=pred, jumps = predict(arima(jumps, order = c(ar,0,0)), n.ahead = steps)))
	} else {
		output <- list()
		for (i in 1:length(steps)) {
			pred <- rep(NA, steps[i])
			pred[1] <- ω + β*λ + γ*rv1
			if (steps[i] == 1) {
				output[[i]] <- list(logvol=pred, jumps = predict(arima(jumps, order = c(ar,0,0)), n.ahead = steps[i]))
			} else {

				for (j in 1:(steps[i]-1)) {
					# Because ε is martingale difference sequence the expected value should be zero	
					vol <- ξ + φ*pred[j] + d2 * mean(fitted[["z"]]^2)
					pred[j+1] <- ω + β * pred[j] + γ * vol
				}
				output[[i]] <- list(logvol=pred, jumps = predict(arima(jumps, order = c(ar,0,0)), n.ahead = steps[i]))
			}
		}
		return(output)
	}
}

# forecast_rGARCH_MLE_jump_n <- function(est, fitted, jumps, rv1, ar = 0, steps = 1) {
# 	jumps <- log(1+jumps)
# 	φ <- est$optim_vals[["φ"]]
# 	d1 <- est$optim_vals[["d1"]]
# 	d2 <- est$optim_vals[["d2"]]
# 	λ <- fitted[["lambda"]][length(fitted[["lambda"]])]
# 	γ <- est$optim_vals[["γ"]]
# 	β <- est$optim_vals[["β"]]
# 	ω <- est$optim_vals[["ω"]]
# 	ξ <- est$optim_vals[["ξ"]]
# 	δ1 <- est$optim_vals[["δ_1"]]
# 	δ2 <- est$optim_vals[["δ_2"]]

# 	if (length(steps) == 1) {
# 		pred <- rep(NA, steps)

# 		pred[1] <- ω + β*λ + γ*rv1 + δ2 * mean(fitted[["z"]]^2)
# 		if (steps == 1) {
# 			return(list(logvol=pred, jumps = predict(arima(jumps, order = c(ar,0,0)), n.ahead = steps)))
# 		}

# 		for (i in 1:(steps-1)) {
# 			# Because ε is martingale difference sequence the expected value should be zero	
# 			vol <- ξ + φ*pred[i] + d2 * mean(fitted[["z"]]^2)
# 			pred[i+1] <- ω + β * pred[i] + γ * vol + δ2 * mean(fitted[["z"]]^2)
# 		}
# 		return(list(logvol=pred, jumps = predict(arima(jumps, order = c(ar,0,0)), n.ahead = steps)))
# 	} else {
# 		output <- list()
# 		for (i in 1:length(steps)) {
# 			pred <- rep(NA, steps[i])
# 			pred[1] <- ω + β*λ + γ*rv1 + δ2 * mean(fitted[["z"]]^2)
# 			if (steps[i] == 1) {
# 				output[[i]] <- list(logvol=pred, jumps = predict(arima(jumps, order = c(ar,0,0)), n.ahead = steps[i]))
# 			} else {

# 				for (j in 1:(steps[i]-1)) {
# 					# Because ε is martingale difference sequence the expected value should be zero	
# 					vol <- ξ + φ*pred[j] + d2 * mean(fitted[["z"]]^2)
# 					pred[j+1] <- ω + β * pred[j] + γ * vol + δ2 * mean(fitted[["z"]]^2)
# 				}
# 				output[[i]] <- list(logvol=pred, jumps = predict(arima(jumps, order = c(ar,0,0)), n.ahead = steps[i]))
# 			}
# 		}
# 		return(output)
# 	}
# }