#include <RcppArmadillo.h>
using namespace Rcpp;
using namespace arma;

// [[Rcpp::export]]
List recursive_filter_jumps_mle_n(NumericVector params, NumericVector ret, NumericVector rv, NumericVector jumps)
{
	int n = ret.size();

	colvec lambda_vals(n);
	colvec u_vals(n);
	colvec z_vals(n);

	double xi = params[0];
	double phi = params[1];
	double d1 = params[2];
	double d2 = params[3];
	
	// double delta_1 = params[4];
	// double delta_2 = params[5];
	// double omega = params[6];
	// double gam = params[7];
	// double bet = params[8];
	// double jumppar = params[9];
	// lambda_vals[0] = params[10];

	double omega = params[4];
	double gam = params[5];
	double bet = params[6];
	double jumppar = params[7];
	lambda_vals[0] = params[8];
	
	z_vals[0] = ret[0]/sqrt(exp(lambda_vals[0]));
	u_vals[0] = rv[0] - xi - phi*lambda_vals[0] - d1*z_vals[0] - d2*(pow(z_vals[0],2)-1);

	for (int i = 1; i < n; i++) {
	    // lambda_vals[i]=omega + bet*lambda_vals[i-1] + gam*rv[i-1] + jumppar*log(1+jumps[i-1]) + delta_1*z_vals[i-1] + delta_2*(pow(z_vals[i-1],2)-1);
	    lambda_vals[i]=omega + bet*lambda_vals[i-1] + gam*rv[i-1] + jumppar*log(1+jumps[i-1]);
	    z_vals[i] = ret[i]/sqrt(exp(lambda_vals[i]));
	    u_vals[i] = rv[i] - xi - phi*lambda_vals[i] - d1*z_vals[i] - d2*(pow(z_vals[i],2)-1);
	}
	
	return(List::create( 
	   _["lambda"]  = lambda_vals, 
	   _["u"]  = u_vals, 
	   _["z"] = z_vals
	 ));
}
